#ifndef BEACON_BEACON_H_
#define BEACON_BEACON_H_
#include "elog.h"
#include "connect.h"
#include "constant.h"
#include "beacon_info.h"


#define ERROR_EXIT_SDK -5

#define NEW_MAP_STRING JMapWrapper_new("string", "string")
#define DELETE_MAP_STRING(map_obj_point) JMapWrapper_del(&(map_obj_point))

typedef struct JMapWrapper Map;

// ־ȼB_DEBUG/B_INFO/B_WARN/B_ERROR/B_ALARM/B_FATAL
void SetLogLevel(unsigned int level);

void SetLogable(BOOL enable_local_log, BOOL enable_realtime_test);

// òϵͳ汾+
void SetDeviceInfo(const char* os_version, const char* model);

// òƷ+Ʒ汾
void SetProductInfo(const char* product_name, const char* product_version);

// 豸Ψһʶ
void SetDeviceID(const char* device_id);

// òƷеûID
void SetUserID(const char* user_id);

// ý
void SetProcessName(const char* argv0);

/**
 * ʼsdk
 * ע: ʼǰһҪҪSetDeviceID趨豸Ψһʶ
 *  ޷ͳջϢ
 */
void InitSDK(const char* app_key, const char* channel);

void ExitSDK();

int ReportEvent(const char* event_name);

int ReportEventWithParams(const char* event_name, Map* params);

int AsynReportEvent(const char* event_name);

int AsynReportEventWithParams(const char* event_name, Map* params);


#endif
