#ifndef BEACON_UTILS_H_
#define BEACON_UTILS_H_

#include "../include/types.h"
#include "../external/zlib/zlib.h"
#include "./Jce_c.h"

#include <stdio.h>  
#include <stdlib.h>  
#include <string.h>

#define  Z_HEADER_SIZE 12  
/* Compress data */
int zcompress(Bytef *data, uLong ndata,
	Bytef *zdata, uLong *nzdata);
/* Uncompress data */
int zdecompress(Bytef *zdata, uLong nzdata,
	Bytef *data, uLong *ndata);
/* gzip Compress data */
int gzcompress(Bytef *data, uLong ndata,
	Bytef *zdata, uLong *nzdata);
int httpgzcompress(Bytef *data, uLong ndata,
	Bytef *zdata, uLong *nzdata);
/* gzip Uncompress data */
int gzdecompress(Bytef *zdata, uLong nzdata,
	Bytef *data, uLong *ndata);
/* http gzip Uncompress data */
int httpgzdecompress(Bytef *zdata, uLong nzdata,
	Bytef *data, uLong *ndata);


int GzipCompress(JString* from, JString* out);

int GzipUnCompress(JString* compress_data, JString* ori_data);


#define SUPPORT_KEY_MAX_LEN 64
#define SUPPORT_VALUE_MAX_LEN 1024

void AddParam(JMapWrapper* param, const char* key, const char* value);

JString* ParseMapToString(JMapWrapper* param);

// ȡǰʱʱms
int64 GetSysTime();

// ȡն˵AES key 16λ
char* GetRandomAesKey();

// aes keyrsaܺ󷵻
char* GetRsaEncryAesKey(const char* aes_key);

void PrintChar(char *s, int len);

#endif
